﻿# -*- coding: utf-8 -*-
import wx
from math import *
import time

app = wx.App()

class minhaTela(wx.Panel):
    def __init__(self, parent,tam):
        wx.Panel.__init__(self,parent,-1,size=tam)
        self.colours = ['Red','Blue','Orange','Green','Yellow','Violet',
                        'Black','Cyan','Brown','Light Blue','Forest Green',
                        'Aquamarine']
        wx.EVT_PAINT(self,self.OnPaint)
        self.InitBuffer()
    
    def InitBuffer(self):
        size = self.GetClientSize()
        self.buffer = wx.EmptyBitmap(size.width, size.height)
        dc = wx.BufferedDC(None, self.buffer)
        dc.SetBackground(wx.Brush(wx.NamedColour('White')))
        dc.Clear()
    
    def OnPaint(self, event):
        dc = wx.BufferedPaintDC(self,self.buffer)
    
    def DoDrawing(self, dc=None, arestas=None):
        if dc is None:
            dc = wx.BufferedDC(wx.ClientDC(self), self.buffer)
        
        if arestas is not None:
            dc.Clear()
            cor = 0
            for linha in arestas:
                dc.SetPen(wx.Pen(wx.NamedColour(self.colours[cor]),1))
                dc.DrawLine(*linha)
                if cor == 11:
                    cor = 0
                else:
                    cor += 1


class rotacao(wx.Frame):
    def __init__(self,parent):
        wx.Frame.__init__(self,parent,-1,"Computaco Graca",size=[600,700])
        sizer = wx.BoxSizer(wx.VERTICAL)
        org = wx.GridSizer(3,2,3,3)
        self.painel = minhaTela(self,[600,600])
        #sizer.Add(wx.Size)
        '''
        org.AddMany([(wx.Button(self,99,'< X'), 0, wx.EXPAND),
                     (wx.Button(self,98,'X >'), 0, wx.EXPAND),
                     (wx.Button(self,97,'< Y'), 0, wx.EXPAND),
                     (wx.Button(self,96,'Y >'), 0, wx.EXPAND),
                     (wx.Button(self,95,'< Z'), 0, wx.EXPAND),
                     (wx.Button(self,94,'Z >'), 0, wx.EXPAND)])
        '''
        org.AddMany([(wx.Slider(self,1,name='X',maxValue=2*pi*100),0,wx.EXPAND),
                     (wx.Slider(self,2,name='Y',maxValue=2*pi*100),0,wx.EXPAND),
                     (wx.Slider(self,3,name='Z',maxValue=2*pi*100),0,wx.EXPAND)])
        sizer.Add(org, 1, wx.EXPAND)
        self.SetSizer(sizer)
        self.Centre()


class matriz(object):
    def __init__ (self, mat=[[]]):
        self.matriz = mat
        self.num_linha = len(mat)
        self.num_coluna = len(mat[0])
    
    def multiplica(self,sec_mat):
        
        if(self.num_coluna != len(sec_mat)):
            return None
    
        #cria uma lista de retultados
        result = []
        #para cada linha
        for i in range(0,self.num_linha):
            result.append([])
            #para cada coluna
            for k in range(0,self.num_coluna):
                result[i].append(0.0)
                #para cada membro da segunda matriz
                for j in range(0, len(sec_mat)):
                    #faz-se o somatorio dos itens da linha vezes o da coluna
                    result[i][k] += self.matriz[i][j]*sec_mat[j][k]
        return matriz(result)


class objeto3d(object):
    def __init__ (self,pontos=[[]],arestas=[[]]):
        self.conjunto_pontos = pontos
        self.conjunto_arestas = arestas
    
    def linhas(self,pontos=[[]]):
        resultado = []
        for i in self.conjunto_arestas:
            reta = []
            for j in pontos[i[0]]:
                reta.append(j)
            for j in pontos[i[1]]:
                reta.append(j)
            resultado.append(reta)
        
        return resultado


class observador(object):
    def __init__ (self, posx=0.0,posy=0.0,posz=0.0,quadro=[0.0,0.0],distancia=0.0):
        self.x = posx
        self.y = posy
        self.z = posz
        self.anteparo = quadro
        self.dist = distancia
        self.gera_matrizes()
    
    def gera_matrizes(self):
        self.trans = matriz([[    1.0,    0.0,    0.0,    0.0],
                             [    0.0,    1.0,    0.0,    0.0],
                             [    0.0,    0.0,    1.0,    0.0],
                             [-self.x,-self.y,-self.z,    1.0]])
        
        self.upx = matriz([[1.0,0.0, 0.0,0.0],
                           [0.0,0.0,-1.0,0.0],
                           [0.0,1.0, 0.0,0.0],
                           [0.0,0.0, 0.0,1.0]])
        
        hip = sqrt(self.x**2 + self.y**2)
        cos = -self.y/hip
        sin = -self.x/hip
        
        self.roty = matriz([[cos,0.0,-sin,0.0],
                            [0.0,1.0, 0.0,0.0],
                            [sin,0.0, cos,0.0],
                            [0.0,0.0, 0.0,1.0]])
        
        nhip = sqrt(hip**2 + self.z**2)
        cos = hip/nhip
        sin = -self.z/nhip
        
        self.rotx = matriz([[1.0,0.0, 0.0,0.0],
                            [0.0,cos,-sin,0.0],
                            [0.0,sin, cos,0.0],
                            [0.0,0.0, 0.0,1.0]])
        
        self.revz = matriz([[1.0,0.0, 0.0,0.0],
                            [0.0,1.0, 0.0,0.0],
                            [0.0,0.0,-1.0,0.0],
                            [0.0,0.0, 0.0,1.0]])
        
        self.N = matriz([[self.dist/(self.anteparo[0]/2),0.0, 0.0,0.0],
                         [0.0,self.dist/(self.anteparo[1]/2), 0.0,0.0],
                         [0.0,0.0,-1.0,0.0],
                         [0.0,0.0, 0.0,1.0]])
        
        self.final = self.trans.multiplica(self.upx.matriz)
        self.final = self.final.multiplica(self.roty.matriz)
        self.final = self.final.multiplica(self.rotx.matriz)
        self.final = self.final.multiplica(self.revz.matriz)
        self.final = self.final.multiplica(self.N.matriz)
    
    def clipping(self,pontos=[[]]):
        
        resultado = []
        
        Vx = self.anteparo[0]/2
        Vy = self.anteparo[1]/2
        
        for i in pontos:
            k = [0.0,0.0]
            k[0] = Vx*(i[0]/i[2])+Vx
            k[1] = Vy*(i[1]/i[2])+Vy
            resultado.append(k)
        
        return resultado
    
    
    def rotate(self,eixo='x',rad=pi/2):
        
        s = sin(rad)
        c = cos(rad)
        
        m = matriz([[  c, -s, -s,0.0],
                    [  s,  c, -s,0.0],
                    [  s,  s,  c,0.0],
                    [0.0,0.0,0.0,1.0]])
        
        if eixo == 'x':
            m.matriz[0][0] = 1.0
            m.matriz[0][1] = 0.0
            m.matriz[0][2] = 0.0
            m.matriz[1][0] = 0.0
            m.matriz[2][0] = 0.0
        elif eixo == 'y':
            m.matriz[0][1] = 0.0
            m.matriz[1][0] = 0.0
            m.matriz[1][1] = 1.0
            m.matriz[1][2] = 0.0
            m.matriz[2][1] = 0.0
        elif eixo == 'z':
            m.matriz[0][2] = 0.0
            m.matriz[1][2] = 0.0
            m.matriz[2][0] = 0.0
            m.matriz[2][1] = 0.0
            m.matriz[2][2] = 1.0
        
        m = (matriz([[self.x,self.y,self.z,1.0]]).multiplica(m.matriz))
        
        self.x = m.matriz[0][0]
        self.y = m.matriz[0][1]
        self.z = m.matriz[0][2]
        
        self.gera_matrizes()


def giraObjeto(evt):
    
    if evt.GetId() == 1:
        eixo = 'x'
    elif evt.GetId() == 2:
        eixo = 'y'
    else:
        eixo = 'z'
    
    angulo = evt.GetPosition() - ang[eixo]
    ang[eixo] = evt.GetPosition()
    o.rotate(eixo,float(angulo)/100)
    m = matriz(a.conjunto_pontos)
    b = m.multiplica(o.final.matriz)
    x = o.clipping(b.matriz)
    k = a.linhas(x)
    painel.DoDrawing(arestas = k)




o = observador(8.0, 0.0, 0.0, [600,600],1200)

a = objeto3d([[-1,1,-1,1],[1,1,-1,1],[1,-1,-1,1],[-1,-1,-1,1],[-1,1,1,1],[1,1,1,1],[1,-1,1,1],[-1,-1,1,1]],[[0,1],[1,2],[2,3],[3,0],[4,5],[5,6],[6,7],[7,4],[0,4],[1,5],[2,6],[3,7]])

ang = dict()
ang['x'] = 0
ang['y'] = 0
ang['z'] = 0


frame = wx.Frame(None,-1,"Computacao Grafica")
tela = rotacao(frame)
painel = tela.painel
m = matriz(a.conjunto_pontos)
b = m.multiplica(o.final.matriz)
x = o.clipping(b.matriz)
k = a.linhas(x)
painel.DoDrawing(k)
tela.Show()
for i in range(1,4):
    tela.Bind(wx.EVT_SCROLL_THUMBTRACK,giraObjeto,id=i)
app.MainLoop()



